<template>
  <div class="about">
    <DataTable :size="TABLE_SIZE.small"
      :data="{ dataSource: listTest, totalElement: totalElement, currentPage: currentPage }" :columns="columns"
      :on-get-data="handleGetAccount" :on-delete-data="handleDeleteAccount" :on-update-active="handleUpdateActive"
      @edit-data="handleEditAccount" :on-loading-table="accountLoading.isLoading.value">

      <template #btn-search>
        <a-input @change="handleSearch" v-model:value="modelRef.textSearch" placeholder="Nhập tên">
          <template #suffix>
            <search-outlined style="color: rgba(0, 0, 0, 0.45)" />
          </template>
        </a-input>

      </template>
      <template #btn-add>
        <DataModal :is-visible="accountModal.isVisible.value" :on-hide-modal="hideModal" :on-excute="handleSubmitModal"
          :on-edit-account="modelRef.detailAccount" :status-active="accountFlag.title.value"
          :modalMode="modelRef.accountMode" />
        <a-button @click="showModal" type="primary">Thêm tài khoản
          <plus-outlined />
        </a-button>
      </template>

      <template #btn-see="props">
        <a-button @click="handleView(props.propName)" type="text">
          <eye-outlined />
        </a-button>
      </template>
    </DataTable>
  </div>
</template>

<script setup>
import { storeToRefs } from "pinia";
import { debounce } from 'lodash-es';
import { message, Modal } from 'ant-design-vue';
import { onMounted, computed, reactive, toRaw, createVNode } from "vue";
import { PlusOutlined, EyeOutlined, ExclamationCircleOutlined, SearchOutlined } from '@ant-design/icons-vue';

import { useTestStore } from "@/stores";
import { TABLE_SIZE, mode } from "@/utils/constants";
import { useLoading, useModal, useFlag } from "@/utils/hooks";

import { columns } from "./child-content/data";
import DataModal from "./child-content/DataModal.vue";
const { listTest, totalElement, currentPage } = storeToRefs(useTestStore());
const { getDataTest, addDataTest, deleteDataTest, updateDataTest, updateActiveTest, searchDataTest } = useTestStore()

const modelRef = reactive({
  detailAccount: {},
  textSearch: "",
  accountMode: ""
});

const accountLoading = useLoading();
const accountModal = useModal();
const accountFlag = useFlag();
const hideModal = () => {
  accountLoading.setLoading(false)
  accountModal.hideModal()
  modelRef.detailAccount = {}
}
const showModal = () => {
  accountModal.showModal()
  accountFlag.statusCreate()
  modelRef.accountMode = mode.CREATE
}
const handleGetAccount = async (data) => {
  accountLoading.setLoading(true)
  try {
    if (modelRef.textSearch) {
      await handleSearchAccount(data)
    } else {
      await getDataTest(data);
    }
  } catch (error) {
    alert(error)
  } finally {
    accountLoading.setLoading(false)
  }
};
const handleSearchAccount = async (data) => {
  accountLoading.setLoading(true);
  try {
    const dataSearch = {
      page: data,
      textSearch: modelRef.textSearch
    }
    await searchDataTest(dataSearch);
  } catch (error) {
    alert(error)
  } finally {
    accountLoading.setLoading(false);
  }
};
const handleEditAccount = async (data) => {
  modelRef.detailAccount = data
  showModal()
  accountFlag.statusEdit()
  modelRef.accountMode = mode.EDIT
}
const handleView = async (data) => {
  modelRef.detailAccount = data
  showModal()
  accountFlag.statusView()
  modelRef.accountMode = mode.VIEW
}
const handleSubmitModal = async (obj) => {
  accountLoading.setLoading(true)
  try {
    if (obj._id) {

      const data = {
        date: obj.date,
        isActive: String(obj.isActive),
        password: obj.password,
        _id: obj._id
      }
      await updateDataTest(toRaw(data))
      hideModal()
      message.success('Sửa thông tin thành công');
      await getDataTest(currentPage.value)
    } else {

      await addDataTest(toRaw(obj))
      hideModal()
      message.success('Tạo tài khoản thành công');
      await getDataTest(1)
    }
  } catch (error) {
    alert(error)
  }

}

const handleDeleteAccount = async (data) => {
  accountLoading.setLoading(true)
  try {
    Modal.confirm({
      title: () => 'Xác nhận xóa tài khoản ' + data.name,
      content: () => 'Bạn có chắc chắn muốn xóa tài khoản này, hành động này sẽ khiến người dùng không thể truy cập vào hệ thống!',
      onOk: async () => {
        await deleteDataTest(data)
        await getDataTest(currentPage.value)
        message.success('Xóa tài khoản thành công thành công');
      },
    })
  } catch (error) {
    alert(error)
  } finally {
    accountLoading.setLoading(false)
  }
}

const handleUpdateActive = async (data) => {
  accountLoading.setLoading(true)
  try {
    Modal.confirm({
      title: () => 'Xác nhận cập nhật tài khoản ?',
      content: () => 'Bạn có chắc chắn muốn cập nhật tài khoản này, hành động này sẽ khiến người dùng không thể truy cập vào hệ thống!',
      onOk: async () => {
        await updateActiveTest(data)
        await getDataTest(currentPage.value)
        message.success('Cập nhật trạng thái thành công');
      },
    })
  } catch (error) {
    alert(error)
  } finally {
    accountLoading.setLoading(false)
  }
}
const handleSearch = debounce(value => {
  try {
    modelRef.textSearch ? handleSearchAccount(1) : handleGetAccount(1)
  } catch (error) {

  }
}, 1000);

onMounted(async () => await handleGetAccount(1))
</script>